-- **************************************************************************
-- * TitanTreasuryTooltip.lua
-- *
-- * By: KanadiaN
-- *       (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanTreasury", true );

-- ********************************************************************************************************
-- NAME : TitanPanelTreasuryButton_GetTooltipText()
-- DESC : Build Tooltip foruse with Titan Panel
-- ********************************************************************************************************
function TitanPanelTreasuryButton_GetTooltipText()
     local CT = TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ][ TitanTreasuryProfile.Player ];
     local CL
     if ( TitanTreasury.General.dColor == "CLASS" ) then
          CL = TitanTreasury_ColorUtils( "GetCClass", CT.Class, LB[ ( "TITAN_TREASURY_TOOLTIP_LINE_%d_%d" ):format( TitanTreasury.General.dStyle, TitanTreasury.General.dType ) ] );
     elseif ( TitanTreasury.General.dColor ~= "CLASS" ) then
          CL = TitanTreasury_ColorUtils( "GetCText", TitanTreasury.General.dColor, LB[ ( "TITAN_TREASURY_TOOLTIP_LINE_%d_%d" ):format( TitanTreasury.General.dStyle, TitanTreasury.General.dType ) ] );
     end
     local TTFR = TitanTreasury_ColorUtils( "GetCFaction", TitanTreasuryProfile.Faction, ( "%s - %s" ):format( TitanTreasuryProfile.Faction, TitanTreasuryProfile.Realm ) );
     local ttUser = TitanTreasury_ColorUtils( "GetCClass", CT.Class, TitanTreasuryProfile.Player );
     local Guild, gName, gLine, pLine, rLine, tLine, mLine, fLine, lLine = "", "", "", "", "", "", "", "", "";
     -- Show Guild Rep
     -- ==============
     local ttGuildRep = ""; 
     if ( IsInGuild() ) then
          if ( TitanTreasury.General.ShowGuildRep ) then
               Guild = GetGuildInfo( "player" );
               for i = 1, GetNumFactions() do
                    name, _, standing, barMin, barMax, barValue, atWarWith, _, isHeader, _, _ = GetFactionInfo( i );
                    if ( not isHeader ) then
                         if ( Guild == name ) then
                              local v, cGradient
                              if ( not v ) then v = {}; end
                              v = {
                                   [1] = ( barValue - barMin ),
                                   [2] = ( barMax - barMin ),
                                   [3] = ( barMax - barMin ) - ( barValue - barMin ),
                                   [4] = math.floor( ( barValue - barMin ) / ( barMax - barMin ) * 100 ),
                                   [5] = ( " %d%%" ):format( math.floor( ( barValue - barMin ) / ( barMax - barMin ) * 100 ) ),
                              };
                              cGradient = TitanTreasury_ColorUtils( "GetCGradient", standing, v[4] );
                              if ( TitanTreasury.Guild.ShowGain ) then
                                   gLine = "gain";
                              end
                              if ( TitanTreasury.Guild.ShowPercent ) then
                                   pLine = TitanTreasury_ColorUtils( "GetCStanding", standing, v[5] );
                              end
                              if ( TitanTreasury.Guild.ShowRaw ) then
                                   rLine = ( " ( %s / %s )" ):format( cGradient:format( v[1] ), TitanTreasury_ColorUtils( "GetCStanding", standing, v[2] ) );
                              end
                              if ( TitanTreasury.Guild.ShowRemain ) then
                                   mLine = ( " %s" ):format( cGradient:format( v[3] ) );
                              end
                              if ( TitanTreasury.Guild.ShowRepText ) then
                                   lLine = ( " %s" ):format( TitanTreasury_ColorUtils( "GetCStanding", standing, false ) );
                              end
                         end
                    end
               end
               local gName = TitanTreasury_ColorUtils( "GetCText", "lime", ( "< %s >" ):format( Guild ) );
               local fLine = ( "%s%s%s%s" ):format( gLine, rLine, mLine, lLine );
               ttGuildRep = gName .. "\t" .. TTFR;
               ttGuildRep = ttGuildRep .. "\n" .. CL;
	       ttGuildRep = ttGuildRep .. "\n" .. pLine .. "\t" .. fLine .. "\n";
          end
     end
     -- Character / Alts Currency Display
     -- =============================
     -- local ttCoin = "\n";
     local ttCoin = "";
     local level, class, gold, cGold, total, mTable = 0, 0, 0, 0, 0, {};
     table.foreach( TitanTreasuryCharacters[ TitanTreasuryProfile.Faction ][ TitanTreasuryProfile.Realm ], function( Key, Data )
               if ( Key == TitanTreasuryProfile.Player ) then
                    table.insert( mTable, { Name = Key, Class = Data.Class, Gold = Data.Gold, rGold = Data.rGold, Level = Data.Level } );
               elseif ( TitanTreasury.General.ShowAlts and Key ~= TitanTreasuryProfile.Player and not Data.Hide ) then
                    table.insert( mTable, { Name = Key, Class = Data.Class, Gold = Data.Gold, Level = Data.Level } );
               end
          end
     )
     mTable = TitanTreasury_CoreUtils( "sortTable", mTable );
     table.foreach( mTable, function( Key, Data )
               if ( Data.Name == TitanTreasuryProfile.Player ) then cGold = Data.rGold; total = total + Data.rGold;
               else cGold = Data.Gold; total = total + Data.Gold; end
               local aLevel = ( "  (%s) %s" ):format( TitanTreasury_ColorUtils( "GetCText", "orange", ( "%02d" ):format( Data.Level ) ), TitanTreasury_ColorUtils( "GetCClass", Data.Class, Data.Name ) );
               local mString = TitanTreasury_CoreUtils( "GetMoney", cGold, "Tooltip" );
               ttCoin = ttCoin .. "\n" .. aLevel .. "\t" .. mString;
          end
     )
     ttCoin = ttCoin .. "\n" .. CL;
     local fancyText = TitanTreasury_ColorUtils( "GetCText", "lime", LB["TITAN_TREASURY_TOOLTIP_TOTAL"] );
     local fancyTotal = TitanTreasury_CoreUtils( "GetMoney", total, "Tooltip" );
     ttCoin = ttCoin .. "\n" .. fancyText .. "\t" .. fancyTotal;
     -- Token Info Display
     -- ==================
     local ttToken = "\n";
     if ( TitanTreasury.General.ShowTokens ) then
          local cCount = GetCurrencyListSize();
          local name, isHeader, isWatched, count, icon, aLevel, mString, ttIcon, pName, pCount;
          local dTokens = 0;
          ttToken = ttToken .. "\n" .. TitanTreasury_ColorUtils( "GetCClass", CT.Class, LB["TITAN_TREASURY_TOOLTIP_TOKENS"]:format( TitanTreasuryProfile.Player ) );
          ttToken = ttToken .. "\n" .. CL;
          for i = 1, cCount do
               name, isHeader, _, _, isWatched, count, icon = GetCurrencyListInfo( i );
	       if ( not isHeader and count > 0 ) then
                    dTokens = dTokens + 1;
                    if ( TitanTreasury.Tokens.TokenIcon ) then
                         if ( TitanTreasury.Tokens.TokenName ) then
                              if ( TitanTreasury.Tokens.TokenColored == 1 ) then
                                   pName = name;
                                   pCount = count;
                              elseif ( TitanTreasury.Tokens.TokenColored == 2 ) then
                                   pName = TitanTreasury_ColorUtils( "GetCText", "sgray", name );
                                   pCount = TitanTreasury_ColorUtils( "GetCText", "lime", count );
                              end
                              ttIcon = ( "  |T%s:%s|t %s" ):format( icon, TitanTreasury.Tokens.TokenIconSize, pName );
                              ttToken = ttToken .. "\n" .. ttIcon .. "\t" .. pCount;
                         elseif ( not TitanTreasury.Tokens.TokenName ) then
                              if ( TitanTreasury.Tokens.TokenColored == 1 ) then
                                   pCount = count;
                              elseif ( TitanTreasury.Tokens.TokenColored == 2 ) then
                                   pCount = TitanTreasury_ColorUtils( "GetCText", "lime", count );
                              end
                              ttIcon = ( "  |T%s:%s|t " ):format( icon, TitanTreasury.Tokens.TokenIconSize );
                              ttToken = ttToken .. "\n" .. ttIcon .. "\t" .. pCount;
                         end
                    elseif ( not TitanTreasury.Tokens.TokenIcon ) then
                         if ( TitanTreasury.Tokens.TokenColored == 1 ) then
                              ttToken = ttToken .. "\n" .. name .. "\t" .. count;
                         elseif ( TitanTreasury.Tokens.TokenColored == 2 ) then
                              ttToken = ttToken .. "\n" .. TitanTreasury_ColorUtils( "GetCText", "sgray", name ) .. "\n" .. TitanTreasury_ColorUtils( "GetCText", "lime", count );
                         end
                    end
               end
          end
          if ( dTokens == 0 ) then ttToken = ''; end
     end
     -- Session Info Display
     -- ====================
     ttSess = "";
     if ( TitanTreasury.Sessions.ShowSession ) then
          local ttSess = "\n";
          local dType, sColor = "", "";
          local sTotal = GetMoney() - CT.Gold;
          if ( sTotal >= 0 ) then
               sColor = "green"; dType = "TRUE";
          elseif ( sTotal < 0 ) then
               sTotal = math.abs( sTotal );
               sColor = "red"; dType = "FALSE";
          end
          ttSess = ttSess .. "\n" .. TitanTreasury_ColorUtils( "GetCText", "sgray", "Session Statistics" );
          ttSess = ttSess .. "\n" .. TitanTreasury_ColorUtils( "GetCText", "white", CL );
          ttSess = ttSess .. "\n" .. TitanTreasury_ColorUtils( "GetCText", "lime", "  Starting Gold : " ) .. "\t" .. TitanTreasury_CoreUtils( "GetMoney", CT.Gold, "Tooltip" );
          local pTime = GetTime() - CT.Session;
          local tHourly = math.floor( sTotal / pTime * 3600 );
          if ( sTotal > 0 ) then
               ttSess = ttSess .. "\n" .. TitanTreasury_ColorUtils( "GetCText", sColor, LB[ ( "TITAN_TREASURY_SESSION_%s" ):format( dType ) ] ) .. "\t" .. TitanTreasury_CoreUtils( "GetMoney", sTotal, "Tooltip" );
          end
          if ( TitanTreasury.General.ShowHourly and tHourly < 0 or sTotal > 0 ) then
               ttSess = ttSess .. "\n" .. TitanTreasury_ColorUtils( "GetCText", sColor, LB[ ( "TITAN_TREASURY_SESSION_HOURLY_%s" ):format( dType ) ] ) .. "\t" .. TitanTreasury_CoreUtils( "GetMoney", tHourly, "Tooltip" );
          end
     end
     -- Addon Memory Info Display
     -- =========================
     local ttMem = "\n";
     if ( TitanTreasury.General.ShowMem ) then
          ttMem = ttMem .. "\n" ..  TitanTreasury_ColorUtils( "GetCText", "sgray", LB["TITAN_TREASURY_TOOLTIP_MEM"] );
          ttMem = ttMem .. "\n" .. TitanTreasury_ColorUtils( "GetCText", "white", CL );
	  ttMem = ttMem .. "\n" .. LB["TITAN_TREASURY_TOOLTIP_MEMTEXT"] .. "\t" .. TitanTreasury_ColorUtils( "GetCText", "lime", ( "%skb" ):format( floor( GetAddOnMemoryUsage( "TitanTreasury" ) ) ) );
     end
     finTooltip = ( "%s%s%s%s%s" ):format( ttGuildRep, ttCoin, ttToken, ttSess, ttMem );
     return finTooltip;
end